using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace Microsoft.Exchange.UserConfiguration
{
	/// <remarks/>
	[Serializable]
	[DesignerCategory("code")]
	[XmlType(Namespace = "CategoryList.xsd")]
	public class Category : INotifyPropertyChanged
	{
		private CategoryColor _ColorField;
		private Guid _IdField;

		private CategoryKeyboardShortcut _KeyboardShortcutField;
		private byte _LastSessionUsedField;

		private DateTime _LastTimeUsedCalendarField;
		private DateTime _LastTimeUsedContactsField;

		private DateTime _LastTimeUsedField;
		private DateTime _LastTimeUsedJournalField;
		private DateTime _LastTimeUsedMailField;
		private DateTime _LastTimeUsedNotesField;
		private DateTime _LastTimeUsedTasksField;
		private string _Name;

		private byte _RenameOnFirstUseField;

		private byte _UsageCountField;
		private bool _RenameOnFirstUseSpecifiedField;

		/// <remarks/>
		[XmlAttribute("name")]
		public string Name
		{
			get { return _Name; }
			set
			{
				_Name = value;
				RaisePropertyChanged("Name");
			}
		}

		/// <remarks/>
		[XmlAttribute("color")]
		public CategoryColor Color
		{
			get { return _ColorField; }
			set
			{
				_ColorField = value;
				RaisePropertyChanged("Color");
			}
		}

		/// <remarks/>
		[XmlAttribute("keyboardShortcut")]
		public CategoryKeyboardShortcut KeyboardShortcut
		{
			get { return _KeyboardShortcutField; }
			set
			{
				_KeyboardShortcutField = value;
				RaisePropertyChanged("KeyboardShortcut");
			}
		}

		/// <remarks/>
		[XmlAttribute("usageCount")]
		public byte UsageCount
		{
			get { return _UsageCountField; }
			set
			{
				_UsageCountField = value;
				RaisePropertyChanged("UsageCount");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedNotes")]
		public DateTime LastTimeUsedNotes
		{
			get { return _LastTimeUsedNotesField; }
			set
			{
				_LastTimeUsedNotesField = value;
				RaisePropertyChanged("LastTimeUsedNotes");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedJournal")]
		public DateTime LastTimeUsedJournal
		{
			get { return _LastTimeUsedJournalField; }
			set
			{
				_LastTimeUsedJournalField = value;
				RaisePropertyChanged("LastTimeUsedJournal");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedContacts")]
		public DateTime LastTimeUsedContacts
		{
			get { return _LastTimeUsedContactsField; }
			set
			{
				_LastTimeUsedContactsField = value;
				RaisePropertyChanged("LastTimeUsedContacts");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedTasks")]
		public DateTime LastTimeUsedTasks
		{
			get { return _LastTimeUsedTasksField; }
			set
			{
				_LastTimeUsedTasksField = value;
				RaisePropertyChanged("LastTimeUsedTasks");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedCalendar")]
		public DateTime LastTimeUsedCalendar
		{
			get { return _LastTimeUsedCalendarField; }
			set
			{
				_LastTimeUsedCalendarField = value;
				RaisePropertyChanged("LastTimeUsedCalendar");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsedMail")]
		public DateTime LastTimeUsedMail
		{
			get { return _LastTimeUsedMailField; }
			set
			{
				_LastTimeUsedMailField = value;
				RaisePropertyChanged("LastTimeUsedMail");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastTimeUsed")]
		public DateTime LastTimeUsed
		{
			get { return _LastTimeUsedField; }
			set
			{
				_LastTimeUsedField = value;
				RaisePropertyChanged("LastTimeUsed");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastSessionUsed")]
		public byte LastSessionUsed
		{
			get { return _LastSessionUsedField; }
			set
			{
				_LastSessionUsedField = value;
				RaisePropertyChanged("LastSessionUsed");
			}
		}

		/// <remarks/>
		[XmlAttribute("guid")]
		public Guid Id
		{
			get { return _IdField; }
			set
			{
				_IdField = value;
				RaisePropertyChanged("Id");
			}
		}

		/// <remarks/>
		[XmlAttribute("renameOnFirstUse")]
		public byte RenameOnFirstUse
		{
			get { return _RenameOnFirstUseField; }
			set
			{
				_RenameOnFirstUseField = value;
				RaisePropertyChanged("RenameOnFirstUse");
			}
		}

		/// <remarks/>
		[XmlIgnore]
		public bool RenameOnFirstUseSpecified
		{
			get { return _RenameOnFirstUseSpecifiedField; }
			set
			{
				_RenameOnFirstUseSpecifiedField = value;
				RaisePropertyChanged("RenameOnFirstUse");
			}
		}

		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion

		protected void RaisePropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler propertyChanged = PropertyChanged;
			if ((propertyChanged != null))
			{
				propertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

	
	}
}