using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Xml.Serialization;

namespace Microsoft.Exchange.UserConfiguration
{
	/// <remarks/>
	[Serializable]
	[DebuggerStepThrough]
	[XmlType(AnonymousType = true, Namespace = "CategoryList.xsd")]
	[XmlRoot(ElementName = "categories", Namespace = "CategoryList.xsd", IsNullable = false)]
	public class MasterCategoryList : object, INotifyPropertyChanged
	{
		private List<Category> categoryField;

		private Guid _DefaultField;

		private byte _LastSavedSessionField;

		private DateTime _LastSavedTimeField;

		/// <remarks/>
		[XmlElement("category")]
		public List<Category> Categories
		{
			get { return categoryField; }
			set
			{
				categoryField = value;
				RaisePropertyChanged("Categories");
			}
		}

		/// <remarks/>
		[XmlAttribute("default")]
		public Guid DefaultCategory
		{
			get { return _DefaultField; }
			set
			{
				_DefaultField = value;
				RaisePropertyChanged("default");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastSavedSession")]
		public byte LastSavedSession
		{
			get { return _LastSavedSessionField; }
			set
			{
				_LastSavedSessionField = value;
				RaisePropertyChanged("lastSavedSession");
			}
		}

		/// <remarks/>
		[XmlAttribute("lastSavedTime")]
		public DateTime LastSavedTime
		{
			get { return _LastSavedTimeField; }
			set
			{
				_LastSavedTimeField = value;
				RaisePropertyChanged("LastSavedTime");
			}
		}

		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion

		protected void RaisePropertyChanged(string propertyName)
		{
			PropertyChangedEventHandler propertyChanged = PropertyChanged;
			if ((propertyChanged != null))
			{
				propertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}

		public static MasterCategoryList Load(TextReader reader)
		{
			var serializer = new XmlSerializer(typeof(MasterCategoryList));
			return (MasterCategoryList)serializer.Deserialize(reader);
		}

		public void Save(TextWriter writer)
		{
			var serializer = new XmlSerializer(typeof(MasterCategoryList));
			serializer.Serialize(writer, this);
		} 
	}
}